Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 13648)
@@ -52,7 +52,4 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
        
        <!-- heat fluxes -->
Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 13648)
@@ -53,7 +53,4 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
        
        <!-- heat fluxes -->
Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-ice.xml	(revision 13648)
@@ -75,7 +75,10 @@
           <field id="utau_bi"      long_name="X-component of ocean bottom stress on sea ice -landfast" standard_name="ocean_bottom_upward_x_stress"              unit="N/m2" />
           <field id="vtau_bi"      long_name="Y-component of ocean bottom stress on sea ice -landfast" standard_name="ocean_bottom_upward_y_stress"              unit="N/m2" />
-          <field id="isig1"        long_name="1st principal stress component for EVP rhg"                                                                        unit=""     />
+          <!-- the fields isig1 isig2 isig3 are obsolete -->
+	  <field id="isig1"        long_name="1st principal stress component for EVP rhg"                                                                        unit=""     />
           <field id="isig2"        long_name="2nd principal stress component for EVP rhg"                                                                        unit=""     />
           <field id="isig3"        long_name="convergence measure for EVP rheology (must be around 1)"                                                           unit=""     />
+          <field id="sig1_pnorm"   long_name="P-normalized 1st principal stress component"                                                                       unit=""     />
+          <field id="sig2_pnorm"   long_name="P-normalized 2nd principal stress component"                                                                       unit=""     />
           <field id="normstr"      long_name="Average normal stress in sea ice"                        standard_name="average_normal_stress"                     unit="N/m"  />
           <field id="sheastr"      long_name="Maximum shear stress in sea ice"                         standard_name="maximum_shear_stress"                      unit="N/m"  />
@@ -398,7 +401,4 @@
 	  <field field_ref="normstr"          name="normstr" />
 	  <field field_ref="sheastr"          name="sheastr" />
-	  <field field_ref="isig1"            name="isig1"   />
-	  <field field_ref="isig2"            name="isig2"   />
-	  <field field_ref="isig3"            name="isig3"   />
 	  
 	  <!-- heat fluxes -->
Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-oce.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-oce.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/field_def_nemo-oce.xml	(revision 13648)
@@ -36,5 +36,5 @@
         <field id="toce_vmean300"     field_ref="toce_e3t_vsum300"  unit="degree_C"     grid_ref="grid_T_vsum"  detect_missing_value="true" > toce_e3t_vsum300/e3t_vsum300 </field>
 
-	<!--- additions to diawri.F90 --->
+	<!-- additions to diawri.F90 -->
         <field id="socegrad"    long_name="module of salinity gradient"              unit="psu/m"   grid_ref="grid_T_3D"/>
         <field id="socegrad2"   long_name="square of module of salinity gradient"    unit="psu2/m2" grid_ref="grid_T_3D"/>
Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml	(revision 13648)
@@ -53,7 +53,4 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
        
        <!-- heat fluxes -->
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/file_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/file_def_nemo-ice.xml	(revision 13648)
@@ -55,7 +55,4 @@
         <field field_ref="normstr"          name="normstr" />
         <field field_ref="sheastr"          name="sheastr" />
-        <field field_ref="isig1"            name="isig1"   />
-        <field field_ref="isig2"            name="isig2"   />
-        <field field_ref="isig3"            name="isig3"   />
 
         <!-- heat fluxes -->
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml	(revision 13647)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml	(revision 13648)
@@ -53,7 +53,4 @@
         <field field_ref="normstr"          name="normstr" />
         <field field_ref="sheastr"          name="sheastr" />
-        <field field_ref="isig1"            name="isig1"   />
-        <field field_ref="isig2"            name="isig2"   />
-        <field field_ref="isig3"            name="isig3"   />
 
         <!-- heat fluxes -->