Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/launch_sasf.sh
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13676)
@@ -12,12 +12,14 @@
 
 CONFIG="STATION_ASF" ; # general name of the configuration
-CONFIG_BLD="STATION_ASF" ; # name of config as build in NEMO... (directory inside "tests" actually contains the compiled test-case?)
+CONFIG_BLD="STATION_ASF2" ; # name of config as build in NEMO... (directory inside "tests" actually contains the compiled test-case?)
 
 # Root directory NEMOGCM reference depository where to fetch compiled STATION_ASF nemo.exe + default namelists:
 NEMO_REF_DIR="/home/laurent/DEV/NEMO/NEMOGCM_dev_r13648_ASINTER-04_laurent_bulk_ice"
-NEMO_WRK_DIR="/home/laurent/NEMO/NEMOvdev_r13648_ASINTER-04_laurent_bulk_ice"
 
 # NEMOGCM root directory where to fetch compiled STATION_ASF nemo.exe:
-SASF_WRK_DIR="${NEMO_WRK_DIR}/tests/${CONFIG_BLD}"
+SASF_WRK_DIR="${NEMO_REF_DIR}/tests/${CONFIG_BLD}"
+
+# DATA_IN_DIR => Directory containing sea-surface + atmospheric forcings:
+DATA_IN_DIR="${NEMO_REF_DIR}/tests/${CONFIG}/input_data"
 
 # Directory where to run the simulation:
@@ -30,7 +32,6 @@
 i_sea_ice=0 ; # default does not compute fluxes over sea-ice
 #
-NFORC="ERA5_arctic" ; i_sea_ice=1 ; FORC="ERA5_arctic_surface_81N_36p75E_1h" ; # string sufficient to copy relevant files as in "*${FORC}*.nc"
-
-#NFORC="PAPA" ; FORC="Station_PAPA_50N-145W" ; # string sufficient to copy relevant files as in "*${FORC}*.nc"
+#NFORC="ERA5_arctic" ; i_sea_ice=1 ; FORC="ERA5_arctic_surface_81N_36p75E_1h" ; # string sufficient to copy relevant files as in "*${FORC}*.nc"
+NFORC="PAPA" ; FORC="Station_PAPA_50N-145W" ; # string sufficient to copy relevant files as in "*${FORC}*.nc"
 
 
@@ -40,4 +41,13 @@
 
 #================================================================================
+
+if [ "`which ncks`" = "" ]; then
+    echo
+    echo "WARNING: you do not seem to have NCO installed here... You should!"
+    echo "      => anyway! will do without, output fields will remaine 3x3 in space :( "
+    echo
+    sleep 4
+fi
+
 HERE=`pwd`
 
@@ -68,10 +78,10 @@
     LIST_OA_ALGOS="ECMWF" ;          # list of air-sea algorithms to test
     LIST_IA_ALGOS="LG15 LU12 CSTC" ; # list of air-ice algorithms to test
-    DIR_NL=${NFORC}/ice ; # where to get the namelists from...
+    DIR_NL=${NFORC}/ice ; # where to fetch the namelists from...
 else
     # Only OPEN-OCEAN/AIR flux computation
-    LIST_OA_ALGOS="NCAR ECMWF" ; # "NCAR ECMWF COARE3p6"; do   ; # list of air-sea algorithms to test
+    LIST_OA_ALGOS="NCAR ECMWF COARE3p6 ANDREAS"; # list of air-sea algorithms to test
     LIST_IA_ALGOS=""
-    DIR_NL=${NFORC}/oce ; # where to get the namelists from...
+    DIR_NL=${NFORC}/oce ; # where to fetch the namelists from...
 fi
 if [ ! -d ${DIR_NL} ]; then echo " Mhhh, seems like forcing ${NFORC} is not meant to be used with sea-ice/air flux computation !"; exit; fi
@@ -86,17 +96,4 @@
 
 
-# DATA_IN_DIR => Directory containing sea-surface + atmospheric forcings
-#             (get it there https://drive.google.com/file/d/1MxNvjhRHmMrL54y6RX7WIaM9-LGl--ZP/):
-if [ `hostname` = "merlat"        ]; then
-    DATA_IN_DIR="/MEDIA/data/STATION_ASF/input_data"
-elif [ `hostname` = "luitel"        ]; then
-    DATA_IN_DIR="/data/gcm_setup/STATION_ASF/input_data"
-elif [ `hostname` = "ige-meom-cal1" ]; then
-    DATA_IN_DIR="/mnt/meom/workdir/brodeau/STATION_ASF/input_data"
-elif [ `hostname` = "salvelinus" ]; then
-    DATA_IN_DIR="/opt/data/STATION_ASF/input_data"
-else
-    echo "Boo!"; exit
-fi
 if [ ! -d ${DATA_IN_DIR} ]; then echo "PROBLEM!!! => did not find directory 'input_data' with input forcing..."; exit; fi
 
@@ -164,17 +161,17 @@
 if [ "${LIST_IA_ALGOS}" = "" ]; then LIST_IA_ALGOS="none"; fi
 
-echo " {LIST_OA_ALGOS} = ${LIST_OA_ALGOS} !"
-echo " {LIST_IA_ALGOS} = ${LIST_IA_ALGOS} !"
+echo
 
 for OA_A in ${LIST_OA_ALGOS}; do
     for IA_A in ${LIST_IA_ALGOS}; do
-        
+
+        echo        
         CASE="${OA_A}"
         if [ ${i_sea_ice} -eq 1 ] && [ "${IA_A}" != "none" ]; then CASE="${OA_A}-${IA_A}"; fi
 
         echo ; echo
-        echo "===================================="
-        echo " Going for ${CASE} experiment"
-        echo "===================================="
+        echo "======================================================================="
+        echo " Going for experiment: ${CASE} bulk param. with ${NFORC} forcing "
+        echo "======================================================================="
         echo
 
@@ -204,6 +201,6 @@
         # Moving output files:
         mkdir -p output
-        mv -f ${CONFIG}-${CASE}_*_grid*.nc output/
-        if [ ${i_sea_ice} -eq 1 ]; then mv -f ${CONFIG}-${CASE}_*_icemod.nc output/; fi
+        mv -f ${CONFIG}-${CASE}_${NFORC}_*_grid*.nc output/
+        if [ ${i_sea_ice} -eq 1 ]; then mv -f ${CONFIG}-${CASE}_${NFORC}_*_icemod.nc output/; fi
 
         # Saving logs:
@@ -213,13 +210,10 @@
         # Making 3x3 to 1 !
         cd output/
-        mkdir -p 3x3
-        list=`\ls ${CONFIG}*${CASE}*.nc | grep -v '_restart_'`
+        list=`\ls ${CONFIG}*${CASE}_${NFORC}_*.nc | grep -v '_restart_'| grep -v '_1p.nc'`
         for ff in ${list}; do
             echo
-            fn=`echo ${ff} | sed -e "s|.nc|_${NFORC}_1p.nc|g"`
-            fb=`echo ${ff} | sed -e "s|.nc|_${NFORC}.nc|g"`
+            fn=`echo ${ff} | sed -e "s|.nc|_1p.nc|g"`
             CMD="ncks -O -d x,1 -d y,1 ${ff} -o ${fn}"
             echo " *** ${CMD}"; ${CMD}
-            mv -f ${ff} 3x3/${fb}
             echo
         done